//------------------------------------------------------------------------------
// <auto-generated />
//
// This file was automatically generated by SWIG (http://www.swig.org).
// Version 3.0.12
//
// Do not make changes to this file unless you know what you are doing--modify
// the SWIG interface file instead.
//------------------------------------------------------------------------------


class cssimplewrapPINVOKE {

  protected class SWIGExceptionHelper {

    public delegate void ExceptionDelegate(string message);
    public delegate void ExceptionArgumentDelegate(string message, string paramName);

    static ExceptionDelegate applicationDelegate = new ExceptionDelegate(SetPendingApplicationException);
    static ExceptionDelegate arithmeticDelegate = new ExceptionDelegate(SetPendingArithmeticException);
    static ExceptionDelegate divideByZeroDelegate = new ExceptionDelegate(SetPendingDivideByZeroException);
    static ExceptionDelegate indexOutOfRangeDelegate = new ExceptionDelegate(SetPendingIndexOutOfRangeException);
    static ExceptionDelegate invalidCastDelegate = new ExceptionDelegate(SetPendingInvalidCastException);
    static ExceptionDelegate invalidOperationDelegate = new ExceptionDelegate(SetPendingInvalidOperationException);
    static ExceptionDelegate ioDelegate = new ExceptionDelegate(SetPendingIOException);
    static ExceptionDelegate nullReferenceDelegate = new ExceptionDelegate(SetPendingNullReferenceException);
    static ExceptionDelegate outOfMemoryDelegate = new ExceptionDelegate(SetPendingOutOfMemoryException);
    static ExceptionDelegate overflowDelegate = new ExceptionDelegate(SetPendingOverflowException);
    static ExceptionDelegate systemDelegate = new ExceptionDelegate(SetPendingSystemException);

    static ExceptionArgumentDelegate argumentDelegate = new ExceptionArgumentDelegate(SetPendingArgumentException);
    static ExceptionArgumentDelegate argumentNullDelegate = new ExceptionArgumentDelegate(SetPendingArgumentNullException);
    static ExceptionArgumentDelegate argumentOutOfRangeDelegate = new ExceptionArgumentDelegate(SetPendingArgumentOutOfRangeException);

    [global::System.Runtime.InteropServices.DllImport("cssimplewrap", EntryPoint="SWIGRegisterExceptionCallbacks_cssimplewrap")]
    public static extern void SWIGRegisterExceptionCallbacks_cssimplewrap(
                                ExceptionDelegate applicationDelegate,
                                ExceptionDelegate arithmeticDelegate,
                                ExceptionDelegate divideByZeroDelegate, 
                                ExceptionDelegate indexOutOfRangeDelegate, 
                                ExceptionDelegate invalidCastDelegate,
                                ExceptionDelegate invalidOperationDelegate,
                                ExceptionDelegate ioDelegate,
                                ExceptionDelegate nullReferenceDelegate,
                                ExceptionDelegate outOfMemoryDelegate, 
                                ExceptionDelegate overflowDelegate, 
                                ExceptionDelegate systemExceptionDelegate);

    [global::System.Runtime.InteropServices.DllImport("cssimplewrap", EntryPoint="SWIGRegisterExceptionArgumentCallbacks_cssimplewrap")]
    public static extern void SWIGRegisterExceptionCallbacksArgument_cssimplewrap(
                                ExceptionArgumentDelegate argumentDelegate,
                                ExceptionArgumentDelegate argumentNullDelegate,
                                ExceptionArgumentDelegate argumentOutOfRangeDelegate);

    static void SetPendingApplicationException(string message) {
      SWIGPendingException.Set(new global::System.ApplicationException(message, SWIGPendingException.Retrieve()));
    }
    static void SetPendingArithmeticException(string message) {
      SWIGPendingException.Set(new global::System.ArithmeticException(message, SWIGPendingException.Retrieve()));
    }
    static void SetPendingDivideByZeroException(string message) {
      SWIGPendingException.Set(new global::System.DivideByZeroException(message, SWIGPendingException.Retrieve()));
    }
    static void SetPendingIndexOutOfRangeException(string message) {
      SWIGPendingException.Set(new global::System.IndexOutOfRangeException(message, SWIGPendingException.Retrieve()));
    }
    static void SetPendingInvalidCastException(string message) {
      SWIGPendingException.Set(new global::System.InvalidCastException(message, SWIGPendingException.Retrieve()));
    }
    static void SetPendingInvalidOperationException(string message) {
      SWIGPendingException.Set(new global::System.InvalidOperationException(message, SWIGPendingException.Retrieve()));
    }
    static void SetPendingIOException(string message) {
      SWIGPendingException.Set(new global::System.IO.IOException(message, SWIGPendingException.Retrieve()));
    }
    static void SetPendingNullReferenceException(string message) {
      SWIGPendingException.Set(new global::System.NullReferenceException(message, SWIGPendingException.Retrieve()));
    }
    static void SetPendingOutOfMemoryException(string message) {
      SWIGPendingException.Set(new global::System.OutOfMemoryException(message, SWIGPendingException.Retrieve()));
    }
    static void SetPendingOverflowException(string message) {
      SWIGPendingException.Set(new global::System.OverflowException(message, SWIGPendingException.Retrieve()));
    }
    static void SetPendingSystemException(string message) {
      SWIGPendingException.Set(new global::System.SystemException(message, SWIGPendingException.Retrieve()));
    }

    static void SetPendingArgumentException(string message, string paramName) {
      SWIGPendingException.Set(new global::System.ArgumentException(message, paramName, SWIGPendingException.Retrieve()));
    }
    static void SetPendingArgumentNullException(string message, string paramName) {
      global::System.Exception e = SWIGPendingException.Retrieve();
      if (e != null) message = message + " Inner Exception: " + e.Message;
      SWIGPendingException.Set(new global::System.ArgumentNullException(paramName, message));
    }
    static void SetPendingArgumentOutOfRangeException(string message, string paramName) {
      global::System.Exception e = SWIGPendingException.Retrieve();
      if (e != null) message = message + " Inner Exception: " + e.Message;
      SWIGPendingException.Set(new global::System.ArgumentOutOfRangeException(paramName, message));
    }

    static SWIGExceptionHelper() {
      SWIGRegisterExceptionCallbacks_cssimplewrap(
                                applicationDelegate,
                                arithmeticDelegate,
                                divideByZeroDelegate,
                                indexOutOfRangeDelegate,
                                invalidCastDelegate,
                                invalidOperationDelegate,
                                ioDelegate,
                                nullReferenceDelegate,
                                outOfMemoryDelegate,
                                overflowDelegate,
                                systemDelegate);

      SWIGRegisterExceptionCallbacksArgument_cssimplewrap(
                                argumentDelegate,
                                argumentNullDelegate,
                                argumentOutOfRangeDelegate);
    }
  }

  protected static SWIGExceptionHelper swigExceptionHelper = new SWIGExceptionHelper();

  public class SWIGPendingException {
    [global::System.ThreadStatic]
    private static global::System.Exception pendingException = null;
    private static int numExceptionsPending = 0;

    public static bool Pending {
      get {
        bool pending = false;
        if (numExceptionsPending > 0)
          if (pendingException != null)
            pending = true;
        return pending;
      } 
    }

    public static void Set(global::System.Exception e) {
      if (pendingException != null)
        throw new global::System.ApplicationException("FATAL: An earlier pending exception from unmanaged code was missed and thus not thrown (" + pendingException.ToString() + ")", e);
      pendingException = e;
      lock(typeof(cssimplewrapPINVOKE)) {
        numExceptionsPending++;
      }
    }

    public static global::System.Exception Retrieve() {
      global::System.Exception e = null;
      if (numExceptionsPending > 0) {
        if (pendingException != null) {
          e = pendingException;
          pendingException = null;
          lock(typeof(cssimplewrapPINVOKE)) {
            numExceptionsPending--;
          }
        }
      }
      return e;
    }
  }


  protected class SWIGStringHelper {

    public delegate string SWIGStringDelegate(string message);
    static SWIGStringDelegate stringDelegate = new SWIGStringDelegate(CreateString);

    [global::System.Runtime.InteropServices.DllImport("cssimplewrap", EntryPoint="SWIGRegisterStringCallback_cssimplewrap")]
    public static extern void SWIGRegisterStringCallback_cssimplewrap(SWIGStringDelegate stringDelegate);

    static string CreateString(string cString) {
      return cString;
    }

    static SWIGStringHelper() {
      SWIGRegisterStringCallback_cssimplewrap(stringDelegate);
    }
  }

  static protected SWIGStringHelper swigStringHelper = new SWIGStringHelper();


  static cssimplewrapPINVOKE() {
  }


  [global::System.Runtime.InteropServices.DllImport("cssimplewrap", EntryPoint="CSharp_SIMPLE_MAJOR_VERSION_get")]
  public static extern int SIMPLE_MAJOR_VERSION_get();

  [global::System.Runtime.InteropServices.DllImport("cssimplewrap", EntryPoint="CSharp_SIMPLE_MINOR_VERSION_get")]
  public static extern int SIMPLE_MINOR_VERSION_get();

  [global::System.Runtime.InteropServices.DllImport("cssimplewrap", EntryPoint="CSharp_SIMPLE_RELEASE_NUMBER_get")]
  public static extern int SIMPLE_RELEASE_NUMBER_get();

  [global::System.Runtime.InteropServices.DllImport("cssimplewrap", EntryPoint="CSharp_SIMPLE_VERSION_STRING_get")]
  public static extern string SIMPLE_VERSION_STRING_get();

  [global::System.Runtime.InteropServices.DllImport("cssimplewrap", EntryPoint="CSharp_SIMPLE_VERSION_NUM_DOT_STRING_get")]
  public static extern string SIMPLE_VERSION_NUM_DOT_STRING_get();

  [global::System.Runtime.InteropServices.DllImport("cssimplewrap", EntryPoint="CSharp_SIMPLE_VERSION_NUM_STRING_get")]
  public static extern string SIMPLE_VERSION_NUM_STRING_get();

  [global::System.Runtime.InteropServices.DllImport("cssimplewrap", EntryPoint="CSharp_SIMPLE_VERSION_NUMBER_get")]
  public static extern int SIMPLE_VERSION_NUMBER_get();

  [global::System.Runtime.InteropServices.DllImport("cssimplewrap", EntryPoint="CSharp_SIMPLE_BETA_NUMBER_get")]
  public static extern int SIMPLE_BETA_NUMBER_get();

  [global::System.Runtime.InteropServices.DllImport("cssimplewrap", EntryPoint="CSharp_SIMPLE_VERSION_FLOAT_get")]
  public static extern double SIMPLE_VERSION_FLOAT_get();

  [global::System.Runtime.InteropServices.DllImport("cssimplewrap", EntryPoint="CSharp_new_Object__SWIG_0")]
  public static extern global::System.IntPtr new_Object__SWIG_0();

  [global::System.Runtime.InteropServices.DllImport("cssimplewrap", EntryPoint="CSharp_new_Object__SWIG_1")]
  public static extern global::System.IntPtr new_Object__SWIG_1(string jarg1);

  [global::System.Runtime.InteropServices.DllImport("cssimplewrap", EntryPoint="CSharp_delete_Object")]
  public static extern void delete_Object(global::System.Runtime.InteropServices.HandleRef jarg1);

  [global::System.Runtime.InteropServices.DllImport("cssimplewrap", EntryPoint="CSharp_Object_set_name")]
  public static extern void Object_set_name(global::System.Runtime.InteropServices.HandleRef jarg1, string jarg2);

  [global::System.Runtime.InteropServices.DllImport("cssimplewrap", EntryPoint="CSharp_Object_get_name")]
  public static extern string Object_get_name(global::System.Runtime.InteropServices.HandleRef jarg1);

  [global::System.Runtime.InteropServices.DllImport("cssimplewrap", EntryPoint="CSharp_Object_set_data")]
  public static extern int Object_set_data(global::System.Runtime.InteropServices.HandleRef jarg1, global::System.Runtime.InteropServices.HandleRef jarg2, uint jarg3);

  [global::System.Runtime.InteropServices.DllImport("cssimplewrap", EntryPoint="CSharp_Object_get_data__SWIG_0")]
  public static extern int Object_get_data__SWIG_0(global::System.Runtime.InteropServices.HandleRef jarg1, global::System.Runtime.InteropServices.HandleRef jarg2, global::System.Runtime.InteropServices.HandleRef jarg3);

  [global::System.Runtime.InteropServices.DllImport("cssimplewrap", EntryPoint="CSharp_Object_get_data__SWIG_1")]
  public static extern global::System.IntPtr Object_get_data__SWIG_1(global::System.Runtime.InteropServices.HandleRef jarg1, global::System.Runtime.InteropServices.HandleRef jarg2);

  [global::System.Runtime.InteropServices.DllImport("cssimplewrap", EntryPoint="CSharp_CSSIMPLEWRAP_MAJOR_VERSION_get")]
  public static extern int CSSIMPLEWRAP_MAJOR_VERSION_get();

  [global::System.Runtime.InteropServices.DllImport("cssimplewrap", EntryPoint="CSharp_CSSIMPLEWRAP_MINOR_VERSION_get")]
  public static extern int CSSIMPLEWRAP_MINOR_VERSION_get();

  [global::System.Runtime.InteropServices.DllImport("cssimplewrap", EntryPoint="CSharp_CSSIMPLEWRAP_RELEASE_NUMBER_get")]
  public static extern int CSSIMPLEWRAP_RELEASE_NUMBER_get();

  [global::System.Runtime.InteropServices.DllImport("cssimplewrap", EntryPoint="CSharp_CSSIMPLEWRAP_VERSION_STRING_get")]
  public static extern string CSSIMPLEWRAP_VERSION_STRING_get();

  [global::System.Runtime.InteropServices.DllImport("cssimplewrap", EntryPoint="CSharp_CSSIMPLEWRAP_VERSION_NUM_DOT_STRING_get")]
  public static extern string CSSIMPLEWRAP_VERSION_NUM_DOT_STRING_get();

  [global::System.Runtime.InteropServices.DllImport("cssimplewrap", EntryPoint="CSharp_CSSIMPLEWRAP_VERSION_NUM_STRING_get")]
  public static extern string CSSIMPLEWRAP_VERSION_NUM_STRING_get();

  [global::System.Runtime.InteropServices.DllImport("cssimplewrap", EntryPoint="CSharp_CSSIMPLEWRAP_VERSION_NUMBER_get")]
  public static extern int CSSIMPLEWRAP_VERSION_NUMBER_get();

  [global::System.Runtime.InteropServices.DllImport("cssimplewrap", EntryPoint="CSharp_CSSIMPLEWRAP_BETA_NUMBER_get")]
  public static extern int CSSIMPLEWRAP_BETA_NUMBER_get();

  [global::System.Runtime.InteropServices.DllImport("cssimplewrap", EntryPoint="CSharp_CSSIMPLEWRAP_VERSION_FLOAT_get")]
  public static extern double CSSIMPLEWRAP_VERSION_FLOAT_get();
}
